<template>
    <Tabs v-model="activeName" @on-click="handleClick" :name="name" :class="curClassName">
        <template v-if="containerModel.length > 0">
            <template v-for="name of containerModel">
                <slot :name="name"></slot>
            </template>
        </template>
    </Tabs>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component({})
export default class AppTabPanel extends Vue {
    /**
    * 名称
    *
    * @type {string}
    * @memberof AppTabPanel
    */
    @Prop() public name!: string;

    /**
     * 布局模型详情
     *
     * @type {string}
     * @memberof AppTabPanel
     */
    @Prop() public layoutModelDetails: any;

    /**
     * 插槽对象
     *
     * @memberof AppTabPanel
     */
    public containerModel: any[] = [];

    /**
     * 当前激活项
     *
     * @memberof AppTabPanel
     */
    public activeName: string = '';

    /**
     * 组件初始化
     *
     * @memberof SimpleFlexContainer
     */
    public created() {
        this.initTabPage();
    }

    /**
     * 初始化分页
     *
     * @memberof SimpleFlexContainer
     */
    public initTabPage() {
        const curLayoutModel = this.layoutModelDetails[this.name];
        if (curLayoutModel && curLayoutModel.details && curLayoutModel.details.length > 0) {
            curLayoutModel.details.forEach((key: string) => {
                this.containerModel.push(key);
            })
        }
        this.activeName = this.containerModel && this.containerModel.length > 0 ? this.containerModel[0] : '';
        this.layoutModelDetails[this.name].clickPage(this.activeName);
    }

    /**
     * 处理分页点击
     *
     * @memberof SimpleFlexContainer
     */
    public handleClick(tab: any) {
        this.layoutModelDetails[this.name].clickPage(tab);
    }

    /**
    * 当前容器样式类
    */
    get curClassName() {
        return `app-tab-panel ${this.name}`;
    }
}
</script>
<style lang='less'>
</style>